-- Etch1

-- Use this function to perform your initial setup
function setup()
    viewer.mode=FULLSCREEN
    viewer.retainedBacking=true
    contLx=WIDTH*1/4
    contRx=WIDTH*3/4
    contLRy=HEIGHT*1/6-20
    rotL=0
    rotR=0
    tracex=WIDTH/2
    tracey=HEIGHT-50-((HEIGHT-50)-(HEIGHT*2/6))/2
    texty=contLRy+50
    lift=true
    gridx=20
    gridy=35.5733
    guidex=tracex
    guidey=tracey
    amar=color(255, 230, 0)
    bleu=color(0,0,255)
    red=color(255,0,0)
    vert=color(0,255,0)
    blan=color(255)
    negr=color(0)
    fucs=color(255, 0, 200)
    
end

-- This function gets called once every frame
function draw()
    rand=color(math.random(0,255),math.random(0,255),math.random(0,255))
    clr=rand
    rectMode(CENTER)
    --Fondo
    --fill(0)
    
    --Grilla
    if lift==true then
        pushStyle()
        strokeWidth(1)
        stroke(20)
        for i=1,gridx do
            grix=WIDTH/gridx*i
            line(grix,0,grix,HEIGHT)
        end
        for i=1,gridy do
            griy=HEIGHT/gridy*i
            line(0,griy,WIDTH,griy)
        end
        popStyle()
    else
        pushStyle()
        strokeWidth(1)
        stroke(20)
        for i=1,gridx do
            grix=WIDTH/gridx*i
            line(grix,0,grix,HEIGHT)
        end
        for i=1,gridy do
            griy=HEIGHT/gridy*i
            line(0,griy,WIDTH,griy)
        end
        popStyle()
    end
    
    --Fondo control movimiento
    pushStyle()
    fill(40)
    rect(WIDTH/2,HEIGHT*1/6,WIDTH,HEIGHT/3)
    popStyle()
    
    --Guías
    pushStyle()
    fill(40)
    rect(15,HEIGHT/2,30,HEIGHT)
    rect(WIDTH/2,HEIGHT-25,WIDTH,50)
    rect(WIDTH-15,HEIGHT/2,30,HEIGHT)
    popStyle()
    pushStyle()
    stroke(255)
    strokeWidth(1)
    line(20,tracey,28,tracey)
    line(tracex,HEIGHT-40,tracex,HEIGHT-48)
    line(WIDTH-20,tracey,WIDTH-28,tracey)
    line(tracex,HEIGHT*2/6-8,tracex,HEIGHT*2/6-1)
    popStyle()
    
    --Control L
    pushMatrix()
    pushStyle()
    translate(contLx,contLRy)
    rotate(-rotL)
    fill(255)
    fontSize(50)
    text("★" , 0,0)
    popStyle()
    popMatrix()
    
    --Control R
    pushMatrix()
    pushStyle()
    translate(contRx,contLRy)
    rotate(-rotR)
    fill(255)
    fontSize(50)
    text("☆", 0,0)
    popStyle()
    popMatrix()
    
    --Indicador
    pushStyle()
    fill(255)
    text("← / →",contLx,texty)
    text("↓ / ↑",contRx,texty)
    popStyle()
    
    --Levantar
    pushStyle()
    stroke(255)
    strokeWidth(1)
    noFill()
    rect(WIDTH*1/4, HEIGHT-20, 80,25)
    popStyle()
    if lift==true then
        pushStyle()
        fill(255)
        rect(WIDTH*1/4,HEIGHT-20,75,20)
        popStyle()
        pushStyle()
        fill(0)
        text("Lift",WIDTH*1/4,HEIGHT-20)
        popStyle()
    else --lift==false then
        pushStyle()
        stroke(255)
        strokeWidth(1)
        fill(0)
        rect(WIDTH*1/4,HEIGHT-20,75,20)
        popStyle()
        pushStyle()
        fill(255)
        text("Lift",WIDTH*1/4,HEIGHT-20)
        popStyle()
    end
    
    --Trazo
    pushStyle()
    if lift==false then
        --fill(math.random(0,255),math.random(0,255),math.random(0,255))
        fill(clr)
        --fill(clr)
    else fill(255,0)
    end
    ellipse(tracex,tracey,3)
    tracex=tracex
    tracey=tracey
    popStyle()
    
    --Selección de color
    pushStyle()
    
    
end

function touched(t)
    --Mover L
    if t.pos.x>0 and t.pos.x<WIDTH/2-20 and t.pos.y>0 and t.pos.y<HEIGHT*2/6 then
        if t.state==CHANGED then
            rotL=rotL+t.delta.x
            if t.delta.x<0 then
                tracex=tracex-0.5
            else tracex=tracex+0.5
            end
        end
    end
    
    --Mover R
    if t.pos.x>WIDTH/2+20 and t.pos.x<WIDTH and t.pos.y>0 and t.pos.y<HEIGHT*2/6 then
        if t.state==CHANGED then
            rotR=rotR+t.delta.x
            if t.delta.x<0 then
                tracey=tracey-0.5
            else tracey=tracey+0.5
            end
        end
    end
    
    --Levantar
    if t.state==ENDED and lift==false and t.pos.y>HEIGHT*2/6 and t.pos.y<HEIGHT/2 then
        lift=true
    elseif t.state==ENDED and lift==true and t.pos.y>HEIGHT*2/6 and t.pos.y<HEIGHT/2 then
        lift=false
    end
    
end
